//########################
//InDesignCS2、CS3でリンクされている画像を他のフォルダの
//同じ名前の画像に再リンクします。同じファイル名で拡張子が
//違うものに再リンクしたり、ひとつづつ結果を確認しながら再
//リンクできます。
//CS3では本来の機能での再リンクをまずはおすすめします。
//http://study-room.info/id/study/cs3/study12.html
//たけうちとおる
//########################


//ダイアログ表示のおまじない
app.scriptPreferences.userInteractionLevel=1699311169;

main();
function main(){
	var folderobj = getfolder();
	if(! folderobj){
		return;
	}
	//ダイアログを作成する
	var folderpath = folderobj.fsName + "/";
	myDialog = app.dialogs.add({name:"配置画像の再リンク"});
	with(myDialog){
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"ドキュメントのリンクで名前が一致するものだけが再リンクされます。"});
			with(borderPanels.add()){
				with (dialogColumns.add()){
					var myFuncSelect = radiobuttonGroups.add();
					with(myFuncSelect){
						radiobuttonControls.add({staticLabel:"ファイル名と拡張子が一致する", checkedState:true});
						radiobuttonControls.add({staticLabel:"次の拡張子でファイル名が一致する："});
					}
					var myExt = textEditboxes.add({editContents:".psd", minWidth:100 });
				}
			}
			with(borderPanels.add()){
				with (dialogColumns.add()){
					var myrelinkSelect = radiobuttonGroups.add();
					with(myrelinkSelect){
						radiobuttonControls.add({staticLabel:"選択されているオブジェクト"});
						radiobuttonControls.add({staticLabel:"ドキュメント全て", checkedState:true});
					}
					var confirmflg = checkboxControls.add({staticLabel:"確認しながら実行する", checkedState:true})
				}
			}
			staticTexts.add({staticLabel:"(C)2009 Toru Takeuchi このスクリプトはフリーウェアです。"});
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		var myFuncSelectType = myFuncSelect.selectedButton;
		var myrelinkSelectType = myrelinkSelect.selectedButton;
		var myconfirmflg = confirmflg.checkedState;
		var extstr = myExt.editContents;
		myDialog.destroy();
		if(myrelinkSelectType == 0){
			indd_get_selected_box(folderpath,myFuncSelectType,extstr,myconfirmflg);
		}else{
			indd_get_all_box(folderpath,myFuncSelectType,extstr,myconfirmflg);
		}
	}
	else{
		myDialog.destroy();
	}
}
//全てのページのボックスを得る
function indd_get_all_box(folderpath,myFuncSelectType,extstr,myconfirmflg){
	if (app.documents.length != 0){
		var pageObj = app.activeDocument.pages;
		for (p=0; p<pageObj.length; p++){
			app.activeWindow.activePage = app.activeDocument.pages[p];
			total = pageObj[p].allGraphics.length;
			for(s = 0; s<total; s++){
				myPageItem = pageObj[p].allGraphics[s].parent;
				var relinkflg = indd_relink_image(myPageItem,folderpath,myFuncSelectType,extstr,myconfirmflg);
				if(myconfirmflg == true && relinkflg == true){
					myconfirmflg =  myconfirm2();
					if(myconfirmflg == -1){break;}
				}
			}
			if(myconfirmflg == -1){break;}
		}
	}else{
		alert("ドキュメントを開いてください");
	}
}
//選択されたオブジェクトを調べる
function indd_get_selected_box(folderpath,myFuncSelectType,extstr,myconfirmflg){
	if (app.documents.length != 0){
		if (app.selection.length > 0){
			var myselectObjects = new Array;
			for(s = 0; s<app.selection.length; s++){
				myselectObjects.push(app.selection[s]);
			}
			for(s = 0; s<myselectObjects.length; s++){
				myPageItem = myselectObjects[s];
				var relinkflg = indd_relink_image(myPageItem,folderpath,myFuncSelectType,extstr,myconfirmflg);
				if(myconfirmflg == true && relinkflg == true){
					myconfirmflg =  myconfirm2();
					if(myconfirmflg == -1){break;}
				}
			}
		}else{
			alert("配置画像を選択して下さい");
		}
	}else{
		alert("ドキュメントを開いてください");
	}
}

//リンクを変更する
function indd_relink_image(myPageItem,folderpath,myFuncSelectType,extstr,myconfirmflg){
	try{
		var filename = myPageItem.allGraphics[0].itemLink.name;
		if(parseInt(app.version) == 4 && Folder.fs == "Macintosh"){
			var dakuten = "%E3%82%99";
			var handakuten = "%E3%82%9A";
			filename = convertKana(filename,dakuten,1);
			filename = convertKana(filename,handakuten,2);
		}
		if(myFuncSelectType == 1){
			filename = deleteext(filename);
			filename = filename + extstr;
		}
		var newfilepath = folderpath+filename;
		var fileObj = new File(newfilepath);
		if(fileObj.exists){
			var myflg = true;
			if(myconfirmflg){
				moveWindow(myPageItem);
				myflg = confirm("置き換えますか？");
			}
			if(myflg){
				myPageItem.allGraphics[0].itemLink.relink (fileObj);
				myPageItem.allGraphics[0].itemLink.update();
			}
			return true;
		}else{
			//画像がなかった
			return false;
		}
	}catch(msg){
		//画像が配置されていない
		return false;
	}
}
//フォルダ選択ダイアログ
function getfolder(){
	var folderobj = Folder.selectDialog("再リンクしたい画像が入ったフォルダを選択してください");
	return folderobj;
}
//アイテムを選択し表示する。
function moveWindow(theObj){
	var myZoom = app.activeWindow.zoomPercentage;
	app.select(theObj);
	app.activeWindow.zoom(ZoomOptions.showPasteboard);
	app.activeWindow.zoomPercentage = myZoom;
}
//拡張子をトル
function deleteext(filename){
	var flg = false;
	var refilename = "";
	for(i = filename.length-1;i > -1;i--){
		myCha = filename[i];
		if(flg){
			refilename = myCha+refilename;
		}
		if(myCha == "."){
			flg = true;
		}
	}
	return refilename;
}
//古旗一浩さんの本InDesign自動処理実例集より
function convertKana(srcName, code, count)
{
	srcName = srcName.replace(/%E3%82%BF%E3%82%99/g, "%E3%83%80"); // ダだけ特殊処理
	var text = srcName.split(code); // 濁点
	for (var i=0; i<text.length-1; i++)
	{
		var str = text[i];
		if (str == "") continue;
		var body = str.substring(0,str.length-2);
		var footL = str.substring(str.length-2, str.length);
		var hexL = eval("0x"+footL) + count;
		hexL = hexL.toString(16).toUpperCase();
		text[i] = body+hexL;
	}
	return text.join("");
}


function myconfirm2(){
		//ダイアログを作成する
	myDialog = app.dialogs.add({name:"配置画像の再リンク"});
	with(myDialog){
		with(dialogColumns.add()){
			staticTexts.add({staticLabel:"更新しました"});
			with(borderPanels.add()){
				with (dialogColumns.add()){
					var confirmflg = checkboxControls.add({staticLabel:"もう確認しない", checkedState:false})
				}
			}
		}
	}
	var myReturn = myDialog.show();
	//ここから処理を行う
	if (myReturn == true){
		var myconfirmflg = confirmflg.checkedState;
		var myReturnNum = 1;
		if(myconfirmflg == 1){
				myReturnNum = 0;
		}
		myDialog.destroy();
	}else{
		var myReturnNum = -1;
		myDialog.destroy();
	}
	return myReturnNum;
}